//自动版本更新处理方法
(function ($) {
	// 保存设备信息，后台推送消息时需要用到
	$.saveDevInfo = function() {
//		alert('1')
		var cinfo = plus.push.getClientInfo();
		var params = "funid=login_event&eventcode=saveinfo";
		params += "&device_info="+JSON.stringify(plus.device);
		params += "&os_info="+JSON.stringify(plus.os);
		params += "&os_name="+plus.os.name.toLowerCase();
		params += "&run_info="+JSON.stringify(plus.runtime);
		params += "&push_info="+JSON.stringify(cinfo);
		params += "&push_cid="+cinfo.clientid;
		params += "&user_code="+jxm.getSession().user_code;
		
		jxm.post(params, null, {hasmask:false});
	};
//	alert('2')
	//检查最新版本信息
	$.checkVersion = function(force){
		var app_version = '';
		var hdcall = function(data) {
//			alert(JSON.stringify(data))
//			alert('4')
//			alert(data.update_version)
			var v = data.update_version;
			//说明没有新版本
 			if(!v || v.length == 0 || v < app_version) return;
			$.updateVersion(data);
 		};
 		var params = 'funid=app_update&eventcode=chkver';
 		plus.runtime.getProperty( plus.runtime.appid, function ( news ) {
 			app_version = news.version;
 			
// 			alert('---'+app_version+'====='+plus.runtime.version)
			params += '&app_version='+app_version;
			params += '&os_type=' + (plus.os.name == 'Android'?'1':'0');
			params += '&appid='+ news.appid;
			jxm.post(params,hdcall,{hasmask:false});
			
		});
	};
	
	//自动更新版本
	$.updateVersion = function(obj){
		
//		alert(JSON.stringify(obj));
		var update_type = obj.update_type;
 		var os_type = (plus.os.name == 'Android'?'1':'0');
// 		alert(oss_type);
 		var update_note = obj.update_note||'有版本，请尽快升级！';
 		var update_title = obj.update_title;
 		var down_url = obj.down_url;
 		var update_version = obj.update_version;
 		if (!update_title || update_title.length == 0) {
 			update_title = '发现新版本：' + update_version;
 		}
   		
		var update = function() {
//			alert('update_type:'+update_type)
			if(update_type == '0'){
				if(os_type == '0'){
					console.log("ios整包安装");
					//ios整包安装
					plus.runtime.openURL(down_url);
				}else {
					console.log("android整包安装");
					//android整包安装
					plus.nativeUI.showWaiting("正在下载文件...");
					plus.downloader.createDownload( down_url, {filename:"_doc/update/"}, function(d,status){
				        if ( status == 200 ) { 
				            console.log("下载成功："+d.filename);
				            plus.nativeUI.showWaiting("安装文件...");
						    plus.runtime.install(d.filename,{},function(){
						        plus.nativeUI.closeWaiting();
						        console.log("安装apk文件结束！");
						        plus.nativeUI.alert("安装结束！",function(){
						            plus.runtime.restart();
						        });
						    },function(e){
						        plus.nativeUI.closeWaiting();
						        console.log("安装文件失败["+e.code+"]："+e.message);
						        plus.nativeUI.alert("安装文件失败["+e.code+"]："+e.message);
						    });
				        } else {
				            console.log("下载apk失败！");
				            plus.nativeUI.alert("下载失败！");
				        }
				        plus.nativeUI.closeWaiting();
				    }).start();
				}
			} else if(update_type == '1') {
				console.log("差量安装");
				//差量安装
				plus.nativeUI.showWaiting("正在下载升级文件...");
				plus.downloader.createDownload( down_url, {filename:"_doc/update/"}, function(d,status){
			        if ( status == 200 ) { 
			            console.log("下载wgt成功："+d.filename);
			            plus.nativeUI.showWaiting("正在安装...");
					    plus.runtime.install(d.filename,{force:true},function(){
					        plus.nativeUI.closeWaiting();
					        console.log("安装wgt结束！");
					        plus.nativeUI.alert("升级完成！",function(){
					            plus.runtime.restart();
					        });
					    },function(e){
					        plus.nativeUI.closeWaiting();
					        console.log("安装wgt文件失败["+e.code+"]："+e.message);
					        plus.nativeUI.alert("安装文件失败["+e.code+"]："+e.message);
					    });
			        } else {
			            console.log("下载wgt失败！");
			            plus.nativeUI.alert("下载失败！");
			        }
			        plus.nativeUI.closeWaiting();
			    }).start();
			}
		};
		//版本号中含-，说明是项目升级包，需要自动升级
		//if (update_version.indexOf('-') > 0) {
		//	update();
		//} else {
			plus.ui.confirm(update_note, function(event) {
				if (0 == event.index) update();
				else{
					var hdcall = function(){
      				
	      			var url = localStorage.getItem("server_url");
	      			var client_id = localStorage.getItem('client_id');
	      			var userData = localStorage.getItem('userData');
	      			//清楚所有本地数据
	      			localStorage.clear();
	      			//保留服务器地址信息
	      			if (url && url.length > 0) {
	      				localStorage.setItem("server_url", url);
	      			}
	      			
	      			//保留客户端ID
	      			if (client_id && client_id.length > 0) {
	      				localStorage.setItem("client_id", client_id);
	      			}
	      			localStorage.setItem('userData',userData);
//	      			plus.runtime.restart();

					var os = plus.os.name.toLowerCase();
//	      			if (os == 'ios') {
	      				var wm = plus.webview.getLaunchWebview();
	  					wm.loadURL("/index.html")
	  					var ws = plus.webview.all();
		  				mui.each(ws, function(i, obj){
		  					if (obj.id != wm.id) {
		  						obj.close();
		  					}
		  				});
//	      			} else {
//	      				plus.runtime.restart(); 
//	      			}
					
      			};
      			var params = 'funid=login&pagetype=login&eventcode=logout';
      			jxm.post(params, hdcall, {hasmask:false});
				}
			}, update_title, ["立即更新", "取  消"]);
		//}
	};
	
	//比较功能版本信息，更新功能并保存json数据
	$.udpateFunJson = function(oldFunJson,newFunJson){
		var type = oldFunJson.bar_code;
//		alert('type:'+type)
		var oldPacks = oldFunJson.packs;
		var newPacks = newFunJson.packs;
		var newstr = JSON.stringify(newFunJson);
//		alert(newstr)
		//替换本地的功能json
		for(var i in oldPacks){
			var funs = oldPacks[i].funs;
			for(var j in funs){
				var item = funs[j];
				var appfunid = item.app_funid;
				var isShow = item.is_show;
				var str = '\"app_funid\":\"'+appfunid+'\"';
				var index = newstr.indexOf(str);
				if(isShow == "0" && index != -1 ){
				  	var headIndex = newstr.substring(0,index).lastIndexOf("{");
				    var tailIndex = newstr.substring(0,index).length+newstr.substring(index).indexOf("}");
				    var res = newstr.substring(headIndex,tailIndex); 
				    var showRes = '\"is_show\":\"'+isShow+'\"';
				    var replaceRes = res.replace('\"is_show\":\"1\"',showRes);
				    newstr = newstr.replace(res,replaceRes);
				}
			}
		}
		
		localStorage.setItem("cur_user_menu_"+type,newstr);
//		alert('---'+type+'===='+newstr);
	};
	
	//保存功能的json数据到localStorage
	$.saveFunJson = function(record){
//		alert('22:'+JSON.stringify(record))
		for(var i  in record){
			var item = record[i];
			var key = item.bar_code;
			if(key == 'card'|| key == 'oa'){
				var data = localStorage.getItem("cur_user_menu_"+key);
				if(data == null){
					localStorage.setItem('cur_user_menu_'+key,JSON.stringify(item));
				}else{
					data = JSON.parse(data);
					$.udpateFunJson(data,item);
				}
			}
		}
	};
	
	// 取最新的后台授权功能列表，并重新加载业务与办公模块的功能列表
	$.updateRoleFun = function() {
		var hdcall = function(data){
//			alert(JSON.stringify(data))
			var record = data.funInfo||[];
			
			//保存功能的json数据到localStorage
			$.saveFunJson(record);
			
			//检查更新功能版本
//			if (record.length > 0) {
//				$.checkVersion(true);
//			}
			
			//更新业务栏目的功能列表
			var eamwin = plus.webview.getWebviewById("eam-main");
			if (eamwin) mui.fire(eamwin, 'refresh', null);
			//更新办公栏目的功能列表
			var oawin = plus.webview.getWebviewById("oa-main");
			if (oawin) mui.fire(oawin, 'refresh', null);
		}
		var params = "funid=app_role_fun&eventcode=queryFun";
		jxm.post(params,hdcall,{hasmask:false});
	};
	
	//============================后台推送消息统一监听接口==============================
	// 后台推送消息统一监听接口；提供hdcall，方便在具体某个页面监听，而不需要修改通用方法
	$.pushListener = function(hdcall){
//		alert('监听了')
		var fn = function( msg ) {
			alert('1'+JSON.stringify(msg));
			
			var data = '';
			data = msg.payload;
			
			var html = data.toPage;
			var keyid = data.keyid;
			
			jxm.open(html,{extras:{keyid:keyid}});
			
		};
		var fn2 = function( msg ) {
			
			if(plus.os.name == 'Android'){
				
				var data = '';
				data = msg.payload;
	      		data = eval("(" + data + ")");
	      		
				console.log(data);
				var html = data.toPage;
				var keyid = data.keyid;
				
				jxm.open(html,{extras:{keyid:keyid}});
				
			}
			
		};
		//消息格式：{pushtype:’xxx’, data:{xxxx}}
		plus.push.addEventListener( "receive", fn2, false );
		plus.push.addEventListener( "click", fn, false );
	};
	
	//执行推送消息数据请求，格式如：{pushtype:’xxx’, data:{xxxx}}
	$.exePush = function(json) {
		if (!json || !json.data) {
			mui.alert('非法格式的推送数据：'+json+'；必须是：{pushtype:xx, data:{xx}}');
			return;
		}
		if (json.pushtype == 'updateNum') {
			//更新审批消息数量，data格式如：{checknum:5}
			var imwin = plus.webview.getWebviewById("im-main");
			mui.fire(imwin, 'updateNum', json.data);
		} else if (json.pushtype == 'updateRole') {
			//更新角色功能配置，重新从后台取功能分配信息
			$.updateRoleFun();
		} else if (json.pushtype == 'updateApp') {
			//更新项目文件升级包
			$.checkVersion();
		}
	};
	
	
return $;
})(jxm);